
//////////////////////////////////////////////////////////////////////////
// Begin generate IETrafficLightActionHandler.hpp file
//////////////////////////////////////////////////////////////////////////

#pragma once

/************************************************************************
 * (c) copyright    2021
 *                  Generated by AREGtech code generator tool.
 * Generated at     16.08.2021  12:45:39 GMT+02:00 
 ************************************************************************/

/************************************************************************
 * \file            generated/src/private/IETrafficLightActionHandler.hpp
 * \ingroup         TrafficLight State Machine
 * \brief           This is an automatic generated code of TrafficLight action handler.
 ************************************************************************/

/************************************************************************
 * Include files
 ************************************************************************/

#include "generated/src/private/NETrafficLightFSM.hpp"

//////////////////////////////////////////////////////////////////////////
// IETrafficLightActionHandler class declaration 
//////////////////////////////////////////////////////////////////////////
/**
 * \brief   IETrafficLightActionHandler action handler interface.
 *          In this classe are declared all action methods of
 *          TrafficLight State Machine.
 *          To implement State Machine, inherit this class, implement
 *          all action methods. The action handler is triggered from
 *          TrafficLight State Machine on state change or on trigger call.
 **/
class IETrafficLightActionHandler
{

//////////////////////////////////////////////////////////////////////////
// Constructor / Destructor
//////////////////////////////////////////////////////////////////////////
protected:

   /**
    * \brief   IETrafficLightActionHandler constructor is hidden from direct call
    **/
   IETrafficLightActionHandler( void ) = default;

   /**
    * \brief   IETrafficLightActionHandler destructor
    **/
   virtual ~IETrafficLightActionHandler( void ) = default;
   

//////////////////////////////////////////////////////////////////////////
// TrafficLight actions
//////////////////////////////////////////////////////////////////////////
public:
/************************************************************************/
// IETrafficLightActionHandler action overrides
/************************************************************************/

   /**
    * \brief   Action to perform when traffic light is off.
    **/
   virtual void actionPowerOff( void ) = 0;

   /**
    * \brief   Acton to perform when power on the traffic light.
    **/
   virtual void actionPowerOn( void ) = 0;

   /**
    * \brief   Action to perform when vehicle light is yellow.
    **/
   virtual void actionVehicleYellow( void ) = 0;

   /**
    * \brief   Action to perform when vehicle light is red.
    **/
   virtual void actionVehicleRed( void ) = 0;

   /**
    * \brief   Action to perform when pedestrian light is red.
    **/
   virtual void actionPedestrianRed( void ) = 0;

   /**
    * \brief   Action to perform when vehicle light is green.
    * \param   isEastWest    Flag, indicating whether this action is triggered for East-West or South-North direction. The default direction is South-North.
    **/
   virtual void actionVehicleGreen( bool isEastWest ) = 0;

   /**
    * \brief   Action to perform when pedestrian light state is green.
    * \param   isEastWest    Flag, indicating whether this action is triggered for East-West or South-North direction. The default direction is South-North.
    **/
   virtual void actionPedestrianGreen( bool isEastWest ) = 0;

//////////////////////////////////////////////////////////////////////////
// Forbidden calls.
//////////////////////////////////////////////////////////////////////////
private:
    DECLARE_NOCOPY_NOMOVE( IETrafficLightActionHandler );
};

//////////////////////////////////////////////////////////////////////////
// End generate IETrafficLightActionHandler.hpp file
//////////////////////////////////////////////////////////////////////////
